models/Ordenadores.php
<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "ordenadores".
 *
 * @property int $id
 * @property string|null $descripcion
 * @property string|null $procesador
 * @property string|null $memoria
 * @property string|null $discoduro
 * @property int|null $ethernet
 * @property int|null $wifi
 * @property string|null $video
 */
class Ordenadores extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'ordenadores';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['ethernet', 'wifi'], 'integer'],
            [['descripcion'], 'string', 'max' => 800],
            [['procesador', 'memoria', 'discoduro', 'video'], 'string', 'max' => 255],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'descripcion' => 'Descripcion',
            'procesador' => 'Procesador',
            'memoria' => 'Memoria RAM',
            'discoduro' => 'Disco Duro',
            'ethernet' => 'Ethernet',
            'wifi' => 'Wifi',
            'video' => 'Tarjeta de Video',
        ];
    }
}

controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;
use yii\data\ActiveDataProvider;
use app\models\Ordenadores;


class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * MOSTRAR PAGINA DE INICIO
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }

    public function actionAdministrar(){
        $dataProvider=new ActiveDataProvider([
            'query'=>Ordenadores::find()
        ]);
        
        return $this->render("administrar",[
            'dataProvider'=>$dataProvider,
        ]);
    }
    
    public function actionInsertar(){
       $model = new Ordenadores();

        if ($model->load(Yii::$app->request->post())) {
            if ($model->save()) {
                // form inputs are valid, do something here
                return $this->redirect(["site/administrar"]);
            }
        }

        return $this->render('formulario', [
            'model' => $model,
            'boton'=>'Añadir',
            'titulo'=>'Añadir Ordenador'
        ]);
    }
    
    public function actionActualizar($id) {
        $model = Ordenadores::findOne($id);
    
        if($this->request->isPost){
            if ($model->load(Yii::$app->request->post())) {
                if ($model->save()) {
                    // form inputs are valid, do something here
                    return $this->redirect(["site/administrar"]);
                }
    }
    }

    return $this->render('formulario', [
        'model' => $model,
        'boton'=>'Actualizar',
        'titulo'=>'Actualizar datos del ordenador'
    ]);
    }
    
    public function actionEliminar($id) {
        $model= Ordenadores::findOne($id);
        
        if($this->request->isPost){
            if ($model->load(Yii::$app->request->post())) {
                if($model->delete());
                    return $this->redirect(["site/administrar"]);
                }
        }
        return $this->render('formulario',[
           'model'=>$model,
           'boton'=>"Eliminar",
           'titulo'=>'<i class="far fa-trash-alt"></i> Eliminar ordenador'
        ]);
    }
    
    public function actionVer($id) {
        return $this->render("ver",[
            'model'=>Ordenadores::findOne($id),
        ]);
    }
    
    public function actionListar() {
        $dataProvider=new ActiveDataProvider([
            'query'=>Ordenadores::find()
        ]);
        
        return $this->render("listar",[
            'dataProvider'=>$dataProvider,
        ]);
    }
    
}

views/layouts/main.php
<?php

/* @var $this \yii\web\View */
/* @var $content string */

use app\assets\AppAsset;
use app\widgets\Alert;
use yii\bootstrap4\Breadcrumbs;
use yii\bootstrap4\Html;
use yii\bootstrap4\Nav;
use yii\bootstrap4\NavBar;

AppAsset::register($this);
?>
<?php $this->beginPage() ?>
<!DOCTYPE html>
<html lang="<?= Yii::$app->language ?>" class="h-100">
<head>
    <meta charset="<?= Yii::$app->charset ?>">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <?php $this->registerCsrfMetaTags() ?>
    <title><?= Html::encode($this->title) ?></title>
    <?php $this->head() ?>
</head>
<body class="d-flex flex-column h-100">
<?php $this->beginBody() ?>

<header>
    <?php
    NavBar::begin([
        //'brandImage' => Html::img + foto en caso de querer foto
        'brandLabel' => '<i class="fas fa-child"></i>' . Yii::$app->name,
        'brandUrl' => Yii::$app->homeUrl,
        'options' => [
            'class' => 'navbar navbar-expand-md navbar-dark bg-dark fixed-top',
        ],
    ]);
    echo Nav::widget([
        'options' => ['class' => 'navbar-nav'],
        'encodeLabels' => false,
        'items' => [
            ['label' => '<i class="fas fa-check-square"></i> Administrar', 'url' => ['/site/administrar']],
            ['label' => '<i class="fas fa-list"></i> Listar', 'url' => ['/site/listar']],
            
        ],
    ]);
    NavBar::end();
    ?>
</header>

<main role="main" class="flex-shrink-0">
    <div class="container">
        <?= Breadcrumbs::widget([
            'links' => isset($this->params['breadcrumbs']) ? $this->params['breadcrumbs'] : [],
        ]) ?>
        <?= Alert::widget() ?>
        <?= $content ?>
    </div>
</main>

<footer class="footer mt-auto py-3 text-muted">
    <div class="container text-center">
        <i class="fas fa-copyright"></i>    Copyright
    </div>
</footer>

<?php $this->endBody() ?>
</body>
</html>
<?php $this->endPage() ?>

views/site/_listar.php
<?php
use yii\helpers\Html;
use app\widgets\Modal;
?>

<div class="row">
    <h2 class="col-lg-2">
        <?= $model->id ?>
    </h2>
    
    <div class="ml-1 col-lg-8 pt-2">
        <div class="bg-white border p-3">
            <?= Html::encode(substr($model->descripcion,0,100)) . "..." //Encode para no interpretar etiquetas?>
        </div>

        <div class="mt-2 float-right">
            <?= Html::a('<i class="fas fa-plus-circle fa-2x"></i>',['site/ver','id'=>$model->id],['class'=>'botonModal']) ?>
        </div>
    </div>
</div>
<?php
    echo Modal::widget([
       "boton"=>"botonModal" 
    ]);
?>

views/site/administrar.php
<?php

use yii\grid\GridView;
use yii\helpers\Html;
?>


<div class="row">
<?= GridView::widget([
    'dataProvider'=>$dataProvider,
    'columns'=>[
                    'id',
                    'descripcion',
                    'procesador',
                    'memoria',
                    'discoduro',
                    [
                        'attribute'=>'ethernet',
                        'format'=>'raw',
                        'value'=>function($model){
                            //Colocar un checkbox deshabilitado
                            //return Html::activeCheckbox($model,'ethernet',['disabled'=>true]);
                            if($model->wifi){
                                return '<i class="fas fa-check-square"></i>';
                            }else{
                                return '<i class="fas fa-window-close"></i>';
                            }
                        }
                    ],
                    [
                        'attribute'=>'wifi',
                        'format'=>'raw',
                        'value'=>function($model){
                        //Colocar un checkbox deshabilitado
                        //return Html::activeCheckbox($model,'wifi',['disabled'=>true]);
                            if($model->wifi){
                                return '<i class="fas fa-check-square"></i>';
                            }else{
                                return '<i class="fas fa-window-close"></i>';
                            }
                        }
                    ],
                    'video',
                    [
                            'header' => 'Acciones',
                            'headerOptions' => ["class" => "btn-link font-weight-bold"],
                            'class' => 'yii\grid\ActionColumn',
                            'template' => '{insertar} {ver} {actualizar} {eliminar}',
                            'buttons' =>[
                                'insertar' => function ($url,$model,$key) {
                                    return Html::a('<i class="fas fa-plus-circle"></i>',
                                            [
                                                "site/insertar"
                                            ]);
                                },
                                'ver' => function ($url,$model,$key) {
                                    return Html::a('<i class="fas fa-eye"></i>',
                                            [
                                                "site/ver",
                                                "id"=>$model->id
                                            ]);
                                },
                                'actualizar' => function ($url,$model,$key) {
                                    return Html::a('<i class="fas fa-pencil-alt"></i>',
                                            [
                                                "site/actualizar",
                                                "id"=>$model->id
                                            ]);
                                },
                                'eliminar' => function ($url,$model,$key) {
                                    return Html::a('<i class="fas fa-trash-alt"></i>',
                                            [
                                                "site/eliminar",
                                                "id"=>$model->id
                                            ],
                                            [
                                            'data'=>[
                                                'confirm'=>'¿Seguro que quieres eliminar?',
                                                'method'=>'post',
                                            ]
                                            ]
                                            );
                                },

                            ]
                    ]
                ]
        ]);
?>
</div>

<div class="row">
<?= Html::a('Crear ordenador',
        ['site/insertar'],
        ['class'=>'btn btn-primary']);
?>
</div>

views/site/error.php
<?php

/* @var $this yii\web\View */
/* @var $name string */
/* @var $message string */
/* @var $exception Exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/formulario.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;
use kartik\switchinput\SwitchInput;


/* @var $this yii\web\View */
/* @var $model app\models\Ordenadores */
/* @var $form ActiveForm */
?>
<h2 class="bg-secondary p-2 mb-3 text-white">
    <?= $titulo ?>
</h2>
<div class="site-formulario">

    <?php
        $opciones=[
            'template'=>'{label} {input}',
            'inputOptions'=>['class'=>'col-lg-9'],
            'labelOptions'=>['class'=>'col-lg-2'],
            'options'=>['class'=>'row mb-2']
        ];
        
        $opciones1=[
            'template'=>'{label} {input}',
            'inputOptions'=>['class'=>'col-lg-9 p-0'],
            'labelOptions'=>['class'=>'col-lg-1 p-0'],
            'options'=>['form-check form-inline']
        ];
    ?>
    <?php $form = ActiveForm::begin(); ?>
        <?= $form->field($model, 'descripcion',$opciones)->textarea(["rows"=>8]) ?>
        <?= $form->field($model, 'procesador',$opciones) ?>
        <?= $form->field($model, 'memoria',$opciones) ?>
        <?= $form->field($model, 'discoduro',$opciones) ?>
        <?= $form->field($model, 'video',$opciones) ?>
        <?php 
            // con el checkbox como switch
            echo $form->field($model, 'ethernet')
            ->widget(SwitchInput::classname(), [
                'pluginOptions' => [
                    'onText' => 'Con Ethernet',
                    'offText' => 'Sin Ethernet',
            ]
            ])->label(''); //quito el label del control
        ?>
        <?php 
            // con el checkbox normal
            /*
            echo $form->field($model, 'ethernet',$opciones1)
            ->checkbox(['class'=>''],false); 
             */
        ?>
    
        <?php 
            // con el checkbox como switch
            echo $form->field($model, 'wifi')
            ->widget(SwitchInput::classname(), [
                'pluginOptions' => [
                    'onText' => 'Con Wifi',
                    'offText' => 'Sin Wifi',
            ]
            ])->label(''); //quito el label del control; 
        ?>
        <?php /*
            echo $form->field($model, 'wifi',$opciones1)
            ->checkbox(['class'=>''],false); 
            */
        ?>
         
    
        <div class="form-group">
            <?= Html::submitButton($boton, ['class' => 'btn btn-primary']) ?>
        </div>
    <?php ActiveForm::end(); ?>

</div>

views/site/index.php
<?php

/* @var $this yii\web\View */
use yii\helpers\Html;



$this->title = 'Gestión ordenadores';
?>
<div class="site-index">

    <div class="body-content row">
        <div class='col-lg-4'>
            <?= Html::img('@web/imgs/ordenador.jpg',[
                'class'=>'img-fluid circle',
                'style'=>'-webkit-box-shadow: 2px 2px 50px 10px #FFB5FF; box-shadow: 2px 2px 50px 10px #FFB5FF; -webkit-border-radius: 50px 0; border-radius: 50px 0;'
                //'style'=>'border-radius:40px'
                
            ]) ?>
        </div>
        
            <div class="col-lg-7 text-justify">
                
                <p> Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et
                    dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip
                    ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                    fugiat nulla pariatur.
                    Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et
                    dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip
                    ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                    fugiat nulla pariatur.</p>

                
            </div>
            
            
        </div>

    </div>
</div>

views/site/listar.php
<?php
use yii\widgets\ListView;


echo ListView::widget([
    'dataProvider' => $dataProvider,
    'itemView'=>'_listar',
    'options' => [
        "class" => "row"
    ],
    'itemOptions' =>[
        "class" => "col-lg-5 border p-4 m-2",
        "style" => "background-color:#eee",
    ],
    'summaryOptions' =>[
        "class"=> "col-lg-12",
    ]

    
]);
  

views/site/ver.php
<?php

use yii\widgets\DetailView;
use yii\helpers\Html;

echo DetailView::widget([
    "model" => $model,
    'attributes' =>[
            'id',
            'descripcion',
            'procesador',
            'memoria',
            'discoduro',
            [
                'attribute' => 'ethernet',
                'format' => 'raw',
                'value' => function($model){
                    
                    // Colocar un checkbox deshabilitado
                    //return Html::activeCheckbox($model, 'ethernet',['disabled'=>true]);
                    
                    if($model->ethernet){
                        return '<i class="fas fa-check-square"></i>';
                    }else{
                        return '<i class="fas fa-times"></i>';
                    }
                }
            ],
            [
                'attribute' => 'wifi',
                'format' => 'raw',
                'value' => function($model){
                    
                    // Colocar un checkbox deshabilitado
                    //return Html::activeCheckbox($model, 'wifi',['disabled'=>true]);
                    
                    if($model->wifi){
                        return '<i class="fas fa-check-square"></i>';
                    }else{
                        return '<i class="fas fa-times"></i>';
                    }
                }
            ],
            'video',
        ]
]);

echo Html::a("Ver por bloques",
        ['site/verbloques',"id"=>$model->id],
        ["class"=>"btn btn-primary"]);